ADD_CFLAGS = -O
#ADD_CFLAGS = -g

INC	= -I$(HDFINC) 

#LIB	= -L$(HDFLIB) -lmfhdf -ldf -lz

LIB	= -L$(HDFLIB) -L$(HDFEOS_LIB) -lhdfeos \
          -lGctp -lmfhdf -ldf -lz -ljpeg -lm -lsz -lhdf5_hl -lhdf5
	  
TARGET  = comp_sds_diff_img

OBJ    = comp_sds_diff_img.o meta.o alloc_mem.o sds_rw.o str_op.o main_util.o

INC_FILES = qa_tool.h sds_rw.h alloc_mem.h str_op.h main_util.h meta.h

all: $(TARGET)

$(OBJ):	$(INC_FILES)

$(TARGET): $(OBJ) $(INC_FILES)
	$(CC) $(ADD_CFLAGS) -o $(TARGET) $(OBJ) $(LIB)
clean:
	rm -f *.o core

#
# Rules
#
.c.o:
	$(CC) $(ADD_CFLAGS) $(INC) -c $< -o $@
